<html>
<head>
<title>OgreGpuProgramUsage.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGpuProgramUsage.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGpuProgramUsage_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GpuProgramUsage_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GpuProgramUsage_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre 
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037     <span class="keyword">class </span>Pass;
<a name="l00038"></a>00038 
<a name="l00073"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html">00073</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.">GpuProgramUsage</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>::Listener, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">PassAlloc</a>
<a name="l00074"></a>00074     {
<a name="l00075"></a>00075     <span class="keyword">protected</span>:
<a name="l00076"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#aa9470d8b504c842c012506954793cc6b">00076</a>         <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="classOgre_1_1GpuProgramUsage.html#aa9470d8b504c842c012506954793cc6b">mType</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#af80f70922010924ae5ea3d8ceb7e5c35">00077</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* <a class="code" href="classOgre_1_1GpuProgramUsage.html#af80f70922010924ae5ea3d8ceb7e5c35">mParent</a>;
<a name="l00078"></a>00078         <span class="comment">// The program link</span>
<a name="l00079"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#a9da44f0dcbbf0fb37bcb0b92321b4036">00079</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> <a class="code" href="classOgre_1_1GpuProgramUsage.html#a9da44f0dcbbf0fb37bcb0b92321b4036">mProgram</a>;
<a name="l00080"></a>00080 
<a name="l00082"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#acc40c8abeb4e5c906307283ccd96d260">00082</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1GpuProgramUsage.html#acc40c8abeb4e5c906307283ccd96d260" title="program parameters">mParameters</a>;
<a name="l00083"></a>00083         
<a name="l00085"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#a6b0ee311ec8d68e62631716177a2320d">00085</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgramUsage.html#a6b0ee311ec8d68e62631716177a2320d" title="Whether to recreate parameters next load.">mRecreateParams</a>;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087         <span class="keywordtype">void</span> recreateParameters();
<a name="l00088"></a>00088 
<a name="l00089"></a>00089     <span class="keyword">public</span>:
<a name="l00093"></a>00093         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.">GpuProgramUsage</a>(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* parent);
<a name="l00094"></a>00094 
<a name="l00096"></a>00096         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.">GpuProgramUsage</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.">GpuProgramUsage</a>&amp; rhs, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* newparent);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098         ~<a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.">GpuProgramUsage</a>();
<a name="l00099"></a>00099 
<a name="l00101"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#a9c322a46459f43021cb71d3ada369428">00101</a>         <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="classOgre_1_1GpuProgramUsage.html#a9c322a46459f43021cb71d3ada369428" title="Gets the type of program we&#39;re trying to link to.">getType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00102"></a>00102 
<a name="l00113"></a>00113         <span class="keywordtype">void</span> setProgramName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> resetParams = <span class="keyword">true</span>);
<a name="l00120"></a>00120         <span class="keywordtype">void</span> setProgram(<a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; prog);
<a name="l00122"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#a8591c555a993fb63833caf6f013b0670">00122</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; <a class="code" href="classOgre_1_1GpuProgramUsage.html#a8591c555a993fb63833caf6f013b0670" title="Gets the program being used.">getProgram</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mProgram; }
<a name="l00124"></a><a class="code" href="classOgre_1_1GpuProgramUsage.html#a093bd8181272357ef88b8c4a1f5f028e">00124</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GpuProgramUsage.html#a093bd8181272357ef88b8c4a1f5f028e" title="Gets the program being used.">getProgramName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mProgram-&gt;getName(); }
<a name="l00125"></a>00125 
<a name="l00131"></a>00131         <span class="keywordtype">void</span> setParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00134"></a>00134         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> getParameters(<span class="keywordtype">void</span>);
<a name="l00135"></a>00135 
<a name="l00137"></a>00137         <span class="keywordtype">void</span> _load(<span class="keywordtype">void</span>);
<a name="l00139"></a>00139         <span class="keywordtype">void</span> _unload(<span class="keywordtype">void</span>);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141         <span class="comment">// Resource Listener</span>
<a name="l00142"></a>00142         <span class="keywordtype">void</span> unloadingComplete(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* prog);
<a name="l00143"></a>00143         <span class="keywordtype">void</span> loadingComplete(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* prog);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     };
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
